VERSION 5.00
Object = "{32ACDEC0-C52B-11D0-9227-444553540000}#1.0#0"; "SPRITEX.OCX"
Begin VB.Form Demo4Form 
   Caption         =   "SpriteX - Demo4 - Cloning and hit testing"
   ClientHeight    =   4635
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7875
   Icon            =   "Demo4.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   309
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   525
   StartUpPosition =   3  'Windows Default
   Begin SPRITEXLib.SpriteX SpriteX1 
      Height          =   3975
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5895
      _Version        =   65536
      _ExtentX        =   10398
      _ExtentY        =   7011
      _StockProps     =   0
   End
   Begin VB.Label lblStatus 
      Caption         =   " Click on a sprite to find out its index."
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   4320
      Width           =   5535
   End
End
Attribute VB_Name = "Demo4Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Type Anim
    x As Integer
    y As Integer
    Index As Integer
    MoveX As Integer
    MoveY As Integer
    Action As Integer
    Frame As Integer
    Count As Integer
End Type

Private Const NO_DRAG_SPRITE = -1
Dim Bucket(6) As Anim, dragSprite As Integer

Private Sub Form_Load()
    SpriteX1.LoadBackground App.Path & "\bg.gif", False
    Bucket(0).Index = SpriteX1.CreateSprite(App.Path & "\bucket.gif", 48, 48)
    Bucket(0).MoveX = 4
    For n = 1 To 6
        Bucket(n).x = Rnd() * 300
        Bucket(n).y = Rnd() * 200
        Bucket(n).Index = SpriteX1.CloneSprite(Bucket(0).Index, Bucket(n).x, Bucket(n).y)
        Bucket(n).MoveX = 4 + 8 * (Rnd > 0.5)
    Next
    'Initialise dragSprite to none
    dragSprite = NO_DRAG_SPRITE
    SpriteX1.Left = 0
    SpriteX1.Top = 0
    Width = SpriteX1.Width * Screen.TwipsPerPixelX
    Height = (SpriteX1.Height + lblStatus.Height + 30) * Screen.TwipsPerPixelY
    lblStatus.Left = 0
    lblStatus.Top = SpriteX1.Height
    lblStatus.Width = Width
End Sub


Private Sub SpriteX1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim ix As Integer, iy As Integer
    'Convert x and y to screen pixels rather than Twips
    ix = Int(x / Screen.TwipsPerPixelX)
    iy = Int(y / Screen.TwipsPerPixelY)
    result = SpriteX1.HitTest(ix, iy)
    For n = 0 To 6
        If result = Bucket(n).Index Then dragSprite = n
    Next
    If result > 0 Then
        lblStatus.Caption = " The result of HitTest is " & Str(result)
    Else
        lblStatus.Caption = " There is no sprite at (" & Str(ix) & "," & Str(iy) & ")"
    End If
End Sub

Private Sub SpriteX1_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim ix As Integer, iy As Integer
    If dragSprite <> NO_DRAG_SPRITE Then
        ix = x / Screen.TwipsPerPixelX
        iy = y / Screen.TwipsPerPixelY
        Bucket(dragSprite).x = ix
        Bucket(dragSprite).y = iy
        lblStatus.Caption = "Drag sprite " & Str(dragSprite) & " is at (" & Str(ix) & "," & Str(iy) & ")"
    End If
End Sub

Private Sub SpriteX1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    dragSprite = NO_DRAG_SPRITE
    lblStatus.Caption = " Drag sprite released"
End Sub

Private Sub SpriteX1_Timer()
    For n = 0 To 6
        Bucket(n).Frame = (Bucket(n).Frame + 1) Mod 8
        If n <> dragSprite Then
            Bucket(n).x = Bucket(n).x + Bucket(n).MoveX
            If Bucket(n).x < 0 Then Bucket(n).MoveX = 4
            If Bucket(n).x > 400 Then Bucket(n).MoveX = -4
        End If
        SpriteX1.MoveSprite Bucket(n).Index, Bucket(n).x, Bucket(n).y, Bucket(n).Frame
    Next
    SpriteX1.UpdateStage
End Sub


